#ref: http://www.sthda.com/english/wiki/text-mining-and-word-cloud-fundamentals-in-r-5-simple-steps-you-should-know

source("functions.R")
load_packages(c("RColorBrewer", "tm", "SnowballC", "wordcloud", "RColorBrewer" ))

text <- readLines(file.choose()) # load text file
text2 <- readLines(file.choose()) # load text file
text3 <- readLines(file.choose()) # load text file

allText <- paste(text,text2,text3)

docs <- Corpus(VectorSource(text)) # load the data as a corpus



#inspect(docs) #inspect the text file


docs <- tm_map(docs, content_transformer(tolower))
docs <- tm_map(docs, removeNumbers)
docs <- tm_map(docs, removeWords, stopwords("english"))
docs <- tm_map(docs, removePunctuation)
docs <- tm_map(docs, stripWhitespace)
docs <- tm_map(docs, removePunctuation)

myStopwords <-  readLines("myExcludeWords.txt") # my excluded words, add more in the txt file
docs <- tm_map(docs, removeWords, myStopwords) 


dtm <- TermDocumentMatrix(docs) # build a term-document matrix
m <- as.matrix(dtm)
v <- sort(rowSums(m),decreasing=TRUE)
d <- data.frame(word = names(v),freq=v)
head(d, 10) # show the top 10 terms

set.seed(1234)

pdf("../Results/file.pdf") 
wordcloud(words = d$word, freq = d$freq, min.freq = 2,
          max.words=200, random.order=FALSE, rot.per=0.35, 
          colors=brewer.pal(8, "Dark2"))

dev.off()
#further analysis 
findFreqTerms(dtm, lowfreq = 4)
findAssocs(dtm, terms = "glasses", corlimit = 0.3)

barplot(d[1:50,]$freq, las = 2, names.arg = d[1:50,]$word,
        col ="lightblue", main ="Most frequent words",
        ylab = "Word frequencies")

